class MyNumberSystem

def +(other)
  if other.kind_of?(MyNumberSystem)
    result = some_calculation_between_self_and_other
    MyNumberSystem.new(result)
  else
    n1, n2 = other.coerce(self)
    n1 + n2
  end
end

end
